class EmptyQueueException extends Exception {}
class IndexOutOfBoundsException extends Exception {}

public class EfficientQueue<T> {
    class Node {
        T elem;
        Node next = null;
        Node prev = null;
        Node(T elem) { this.elem = elem; }
    }
    private Node head = null, tail = null;
    
    public EfficientQueue() {}

    public void push(T elem) {
        Node n = new Node(elem);
        n.prev = tail;

        if (tail != null) tail.next = n;
        else head = n;
        tail = n;
    }

    public T pop() throws EmptyQueueException {
        if (head == null) throw new EmptyQueueException();
        Node n = head;
        head = n.next;
        if (head != null) head.prev = null;
        else tail = null;
        return n.elem;
    }

    public static void main(String args[]) {
        EfficientQueue<MyClass> myq = new EfficientQueue<MyClass>();

        myq.push(new MyClass());
        myq.push(new MyClass());
        myq.push(new MyClass());
        myq.push(new MyClass());

        try {
            while (true) 
                System.out.println(myq.pop().get());
        } catch(EmptyQueueException e) {
            System.out.println("empty!");
        }
    }
}
